services:
  cambridge_core_api.user_auth:
    class: Drupal\cambridge_core_api\UserAuth
    arguments: ['@config.factory', '@http_client', '@logger.channel.cambridge_core_api']
  cambridge_core_api.external_auth:
    class: Drupal\cambridge_core_api\ExternalAuthRunner
    arguments: [ '@request_stack', '@externalauth.externalauth' , '@current_user']
  cambridge_core_api.ip_login:
    class: Drupal\cambridge_core_api\IpLogin
    arguments: ['@request_stack','@cambridge_core_api.user_auth', '@cambridge_core_api.external_auth']
  cambridge_core_api.ip_logout:
    class: Drupal\cambridge_core_api\IpLogout
    arguments: ['@current_user', '@externalauth.authmap']
  cambridge_core_api.external_auth_login_subscriber:
    class: Drupal\cambridge_core_api\EventSubscriber\ExternalAuthLoginSubscriber
    arguments: ['@request_stack', '@kernel', '@cambridge_core_api.ip_logout', '@current_user', '@tempstore.private']
    tags:
      - { name: event_subscriber }
  cambridge_core_api.route_subscriber:
    class: Drupal\cambridge_core_api\EventSubscriber\RouteSubscriber
    tags:
      - { name: event_subscriber }
  cambridge_core_api.page_cache_request_policy.user_login_page_requests:
    class: Drupal\cambridge_core_api\PageCache\UserLoginPageRequests
    tags:
      - { name: page_cache_request_policy }
  cache_context.http_x_forwarded_for:
    class: Drupal\cambridge_core_api\Cache\Context\HttpXForwardedForCacheContext
    arguments: ['@request_stack']
    tags:
      - { name: cache.context }
  logger.channel.cambridge_core_api:
    class: Drupal\Core\Logger\LoggerChannel
    factory: ['@logger.factory', 'get']
    arguments: ['cambridge_core_api']
  cambridge_core_api.ip_auto_login_requester_middleware:
    class: Drupal\cambridge_core_api\StackMiddleware\IpAutoLoginUserDataRequester
    tags:
      - {name: http_middleware, priority: 250, responder: true}
    calls:
      - [setContainer, ['@service_container']]
  cambridge_core_api.ip_auto_login_middleware:
    class: Drupal\cambridge_core_api\StackMiddleware\IpAutoLogin
    tags:
      - {name: http_middleware, priority: 30}
    calls:
      - [setContainer, ['@service_container']]
  cambridge_core_api.kernel_response_subscriber:
    class: Drupal\cambridge_core_api\EventSubscriber\KernelResponseSubscriber
    tags:
      - { name: event_subscriber }
  cambridge_core_api.statistics:
    class: Drupal\cambridge_core_api\Statistics
    arguments: [ '@config.factory', '@http_client', '@logger.channel.cambridge_core_api', '@event_dispatcher' ]
